Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.pentaho.di.trans.step
Interface StepInterface

All Known Implementing Classes:
  Abort, AccessInput, AccessOutput, AddSequence, AddXML, AggregateRows, AnalyticQuery, Append, BaseStep, BlockingStep, Calculator, CheckSum, CloneRow, ClosureGenerator, ColumnExists, CombinationLookup, Constant, CreditCardValidator, CsvInput, CubeInput, CubeOutput, DatabaseJoin, DatabaseLookup, DBProc, Delay, Delete, Denormaliser, DetectEmptyStream, DetectLastRow, DimensionLookup, DummyTrans, DynamicSQLRow, ExcelInput, ExcelOutput, ExecProcess, ExecSQL, ExecSQLRow, FieldSplitter, FileExists, FilesFromResult, FilesToResult, FilterRows, FixedInput, Flattener, Formula, GetFileNames, GetFilesRowsCount, GetPreviousRowField, GetSubFolders, GetVariable, GetXMLData, GPBulkLoader, GroupBy, HTTP, HTTPPOST, IfNull, InfobrightLoader, Injector, InsertUpdate, Janino, JoinRows, LDAPInput, LDIFInput, LucidDBBulkLoader, Mail, MailValidator, Mapping, MappingInput, MappingOutput, MergeJoin, MergeRows, MondrianInput, MonetDBBulkLoader, MySQLBulkLoader, Normaliser, NullIf, NumberRange, OraBulkLoader, ParGzipCsvInput, PGBulkLoader, ProcessFiles, PropertyInput, PropertyOutput, RandomValue, RegexEval, ReplaceString, ReservoirSampling, RowGenerator, RowsFromResult, RowsToResult, RssInput, RssOutput, SalesforceInput, SampleRows, ScriptValuesMod, ScriptValuesModDummy, SelectValues, SetValueConstant, SetValueField, SetVariable, SocketReader, SocketWriter, SortedMerge, SortRows, SplitFieldToRows, SQLFileOutput, StepMetastructure, StreamLookup, StringCut, SwitchCase, SynchronizeAfterMerge, SystemData, TableExists, TableInput, TableOutput, TextFileInput, TextFileOutput, UniqueRows, UniqueRowsByHashSet, UnivariateStats, Update, Validator, ValueMapper, WebService, WriteToLog, XBaseInput, XMLInput, XMLInputSax, XMLJoin, XMLOutput, XsdValidator, Xslt

    public interface StepInterface

Method Summary
`void` | `addRowListener(RowListener rowListener)` Add a rowlistener to the step allowing you to inspect (or manipulate, be careful) the rows coming in or exiting the step.
`void` | `addStepListener(StepListener stepListener)` Attach a step listener to be notified when a step arrives in a certain state.
`void` | `cleanup()` Call this method typically, after ALL the slave transformations in a clustered run have finished.
`void` | `dispose(StepMetaInterface sii, StepDataInterface sdi)` Dispose of this step: close files, empty logs, etc.
`int` | `getCopy()`
`long` | `getErrors()` Get the number of errors
`List<org.pentaho.di.core.RowSet>` | `getInputRowSets()`
`long` | `getLinesInput()`
`long` | `getLinesOutput()`
`long` | `getLinesRead()`
`long` | `getLinesRejected()`
`long` | `getLinesUpdated()`
`long` | `getLinesWritten()`
`List<org.pentaho.di.core.RowSet>` | `getOutputRowSets()`
`String` | `getPartitionID()`
`Object[]` | `getRow()`
`List<RowListener>` | `getRowListeners()`
`String` | `getStepID()`
`StepMeta` | `getStepMeta()`
`String` | `getStepname()` Get the name of the step.
`boolean` | `init(StepMetaInterface stepMetaInterface, StepDataInterface stepDataInterface)` Initialise and do work where other steps need to wait for...
`void` | `initBeforeStart()` This method is executed by Trans right before the threads start and right after initialization. !!! A plugin implementing this method should make sure to also call super.initBeforeStart(); !!!
`boolean` | `isAlive()` Is the thread still alive?
`boolean` | `isMapping()`
`boolean` | `isPartitioned()`
`boolean` | `isStopped()`
`void` | `markStart()` Mark the start time of the step.
`void` | `markStop()` Mark the end time of the step.
`void` | `pauseRunning()` Pause a running step
`boolean` | `processRow(StepMetaInterface smi, StepDataInterface sdi)` Process one row.
`void` | `putRow(org.pentaho.di.core.row.RowMetaInterface row, Object[] data)` Put a row on the destination rowsets.
`void` | `removeRowListener(RowListener rowListener)` Remove a rowlistener from this step.
`void` | `resumeRunning()` Resume a running step
`void` | `run()` Run is where the action happens in a step...
`void` | `setErrors(long errors)` Sets the number of errors
`void` | `setLinesRejected(long linesRejected)`
`void` | `setOutputDone()` Signal output done to destination steps
`void` | `setPartitionID(String partitionID)`
`void` | `start()` Starts the thread...
`void` | `stopAll()` Flags all rowsets as stopped/completed/finished.
`void` | `stopRunning(StepMetaInterface stepMetaInterface, StepDataInterface stepDataInterface)` Stop running operations...

Method Detail

### init

    boolean init(StepMetaInterface stepMetaInterface,
                 StepDataInterface stepDataInterface)

  Initialise and do work where other steps need to wait for...

  Parameters:
    `stepMetaInterface` - The metadata to work with
    `stepDataInterface` - The data to initialize

### dispose

    void dispose(StepMetaInterface sii,
                 StepDataInterface sdi)

  Dispose of this step: close files, empty logs, etc.

  Parameters:
    `sii` - The metadata to work with
    `sdi` - The data to dispose of

### markStart

    void markStart()

  Mark the start time of the step.

### markStop

    void markStop()

  Mark the end time of the step.

### start

    void start()

  Starts the thread...

### stopRunning

    void stopRunning(StepMetaInterface stepMetaInterface,
                     StepDataInterface stepDataInterface)
                     throws org.pentaho.di.core.exception.KettleException

  Stop running operations...

  Parameters:
    `stepMetaInterface` - The metadata that might be needed by the step to stop running.
    `stepDataInterface` - The interface to the step data containing the connections, resultsets, open files, etc.
  Throws:
    `org.pentaho.di.core.exception.KettleException`

### isAlive

    boolean isAlive()

  Is the thread still alive?

  Returns:
    true if the thread is still alive...

### isStopped

    boolean isStopped()

  Returns:
    True if the step is marked as stopped. Execution should stop immediate.

### stopAll

    void stopAll()

  Flags all rowsets as stopped/completed/finished.

### pauseRunning

    void pauseRunning()

  Pause a running step

### resumeRunning

    void resumeRunning()

  Resume a running step

### run

    void run()

  Run is where the action happens in a step...

### getStepname

    String getStepname()

  Get the name of the step.

  Returns:
    the name of the step

### getCopy

    int getCopy()

  Returns:
    The steps copy number (default 0)

### getStepID

    String getStepID()

  Returns:
    the type ID of the step...

### getErrors

    long getErrors()

  Get the number of errors

  Returns:
    the number of errors

### setErrors

    void setErrors(long errors)

  Sets the number of errors

  Parameters:
    `errors` - the number of errors to set

### getLinesInput

    long getLinesInput()

  Returns:
    Returns the linesInput.

### getLinesOutput

    long getLinesOutput()

  Returns:
    Returns the linesOutput.

### getLinesRead

    long getLinesRead()

  Returns:
    Returns the linesRead.

### getLinesWritten

    long getLinesWritten()

  Returns:
    Returns the linesWritten.

### getLinesUpdated

    long getLinesUpdated()

  Returns:
    Returns the linesUpdated.

### setLinesRejected

    void setLinesRejected(long linesRejected)

  Parameters:
    `linesRejected` - steps the lines rejected by error handling.

### getLinesRejected

    long getLinesRejected()

  Returns:
    Returns the lines rejected by error handling.

### processRow

    boolean processRow(StepMetaInterface smi,
                       StepDataInterface sdi)
                       throws org.pentaho.di.core.exception.KettleException

  Process one row.

  Parameters:
    `smi` - The metadata to work with
    `sdi` - The temporary working data to work with (database connections, resultsets, caches, temporary variables, etc.)
  Returns:
    false if no more rows can be processed or an error occurred.
  Throws:
    `org.pentaho.di.core.exception.KettleException`

### putRow

    void putRow(org.pentaho.di.core.row.RowMetaInterface row,
                Object[] data)
                throws org.pentaho.di.core.exception.KettleException

  Put a row on the destination rowsets.

  Parameters:
    `row` - The row to send to the destinations steps
  Throws:
    `org.pentaho.di.core.exception.KettleException`

### getRow

    Object[] getRow()
                    throws org.pentaho.di.core.exception.KettleException

  Returns:
    a row from the source step(s).
  Throws:
    `org.pentaho.di.core.exception.KettleException`

### setOutputDone

    void setOutputDone()

  Signal output done to destination steps

### addRowListener

    void addRowListener(RowListener rowListener)

  Add a rowlistener to the step allowing you to inspect (or manipulate, be careful) the rows coming in or exiting the step.

  Parameters:
    `rowListener` - the rowlistener to add

### removeRowListener

    void removeRowListener(RowListener rowListener)

  Remove a rowlistener from this step.

  Parameters:
    `rowListener` - the rowlistener to remove

### getRowListeners

    List<RowListener> getRowListeners()

  Returns:
    a list of the installed RowListeners

### getInputRowSets

    List<org.pentaho.di.core.RowSet> getInputRowSets()

  Returns:
    The list of active input rowsets for the step

### getOutputRowSets

    List<org.pentaho.di.core.RowSet> getOutputRowSets()

  Returns:
    The list of active output rowsets for the step

### isPartitioned

    boolean isPartitioned()

  Returns:
    true if the step is running partitioned

### setPartitionID

    void setPartitionID(String partitionID)

  Parameters:
    `partitionID` - the partitionID to set

### getPartitionID

    String getPartitionID()

  Returns:
    the steps partition ID

### cleanup

    void cleanup()

  Call this method typically, after ALL the slave transformations in a clustered run have finished.

### initBeforeStart

    void initBeforeStart()
                         throws org.pentaho.di.core.exception.KettleStepException

  This method is executed by Trans right before the threads start and right after initialization.
  !!! A plugin implementing this method should make sure to also call super.initBeforeStart(); !!!

  Throws:
    `org.pentaho.di.core.exception.KettleStepException` - In case there is an error

### addStepListener

    void addStepListener(StepListener stepListener)

  Attach a step listener to be notified when a step arrives in a certain state. (finished)

  Parameters:
    `stepListener` - The listener to add to the step

### isMapping

    boolean isMapping()

  Returns:
    true if the thread is a special mapping step

### getStepMeta

    StepMeta getStepMeta()

  Returns:
    The metadata for this step

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD